"""
Este archivo se ha concebido para ser usado desde la línea de comandos, como primera fase para aprender Python
Aunque también podrá ser usado de otros modos que se verán en el curso
Es recomendable leer esta página columna probar sus ejemplos.

       Marzo de 2022

    Angel Luis Aldana Valverde
        angel.l.aldana@prohimet.org
        https://www.edaphi.es
        https://www.angel-l-aldana.com
		
"""
# Recuerda que esto son comentarios
# Y lo siguiente ayuda a documentar el texto
'''
Algo sobre números
Experimenta con expresiones como las siguientes
'''
# Puedes usar el intérprete como una calculadora
# >>> 2 + 2
print(2 + 2)
# O definir una variable como entera
# >>> mi_var_ent = 2
# >>> mi_var_ent
mi_var_ent = 2  # equivalente a mi_var_ent=int(2)
print(mi_var_ent)
# Observa la diferencia entre los dos resultados siguientes
# >>> mi_var_ent * 4
# >>> mi_var_ent * 4.0
print(mi_var_ent * 4)
print(mi_var_ent * 4.0)
# Interpreta las siguientes operaciones con divisiones
# >>> 17 / 3
# >>> 17 / 3.0
# >>> 17 // 3.0
# >>> 17 % 3
print(17 / 3)
print(17 / 3.0)
print(17 // 3.0)
print(17 % 3)
# Ahora más operaciones usando variables.
# >>> mi_base = 5
# >>> print mi_base ** mi_var_ent
mi_base = 5
# >>> print mi_base ** mi_var_ent
print(mi_base ** mi_var_ent)
'''
Ahora a experimentar con cadenas de caracteres o textos (string)
'''
mi_cadena = "esto es una cadena"
# >>> print(mi_cadena)
print(mi_cadena)
mi_cadena = '"Quiero incluir comillas dobles"'
# >>> mi_cadena
print(mi_cadena)
# >>>
mi_cadena = '\"También puede ser así \"'
# >>> mi_cadena
print(mi_cadena)
mi_cadena = "Y puedo\nseparala en líneas"
# >>> mi_cadena
print(mi_cadena)
# Veamos como podemos trabajar con los caracteres de un texto
mi_cadena = "ABCDE"
# >>> mi_cadena
print(mi_cadena)
# Ya vamos a usar una función general de Python (de las denominadas "built-in")
# >>> len(mi_cadena)
print(len(mi_cadena))
# >>> mi_cadena[0]
print(mi_cadena[0])
# >>> mi_cadena[len(mi_cadena) - 1]
print(mi_cadena[len(mi_cadena) - 1])
# Para operar con fragmentos:
# >>> mi_cadena[1:3]
print(mi_cadena[1:3])
# >>> mi_cadena[:3]
print(mi_cadena[:3])
# >>> mi_cadena[1:]
print(mi_cadena[1:])
# Podemos concatenar cadenas de un modo simple
# >>> "El valor de la variable cadena es: " + mi_cadena
print("El valor de la variable cadena es: " + mi_cadena)
'''
Ahora Listas (List), el tipo de variable más versátil de Python
'''
cuadrados = [1, 4, 9, 16, 25]
# >>> cuadrados
print(cuadrados)
# Mira la analogía con las cadenas
# >>> len(cuadrados)
print(len(cuadrados))
# >>> cuadrados[0]
print(cuadrados[0])
# >>> cuadrados[len(cuadrados) - 1]
print(cuadrados[len(cuadrados) - 1])
'''
Incluimos ya una instrucción de bucle "for" para crear la misma lista
Un avance de lo que se verá más adelante
'''
cuadrados = [i ** 2 for i in [1, 2, 3, 4, 5]]
# >>> cuadrados
print(cuadrados)
# Las listas también se pueden concatenar
# >>> cuadrados + [1, 2, 3, 4, 5]
print(cuadrados + [1, 2, 3, 4, 5])
# O se puede añadir un elemento
cuadrados.append(36)
# >>> cuadrados
print(cuadrados)
# Ahora lista de listas
a1 = [11, 12]
a2 = [21, 22]
b = [a1, a2]
# >>> b
print(b)
# >>> b[1][0]
print(b[1][0])
'''
range: Otra función que será útil. Experimenta con ella
'''
# >>>  [i for i in range(0,8)]
print([i for i in range(0,8)])
# >>>  [i for i in range(0,8)]
print([i for i in range(8)])
# >>>  [i for i in range(2,8)]
print([i for i in range(2,8)])
# >>>  [i for i in range(2, 8, 2)]
print([i for i in range(2, 8, 2)])
'''
Muy útil para formatear salidas de resultados. Prueba con print
Ver también https://docs.python.org/3.6/tutorial/inputoutput.html#fancier-output-formatting
'''
n_entero = 2
# >>>'{0:2d} {1:3d} {2:4d}'.format(n_entero, n_entero * n_entero, n_entero ** 3)
# >>>print('{0:2d} {1:3d} {2:4d}'.format(n_entero, n_entero * n_entero, n_entero ** 3))
print('{0:2d} {1:3d} {2:4d}'.format(n_entero, n_entero * n_entero, n_entero ** 3))
n_real = 9.12345
# >>>'{0:2.1f} {1:3d} {2:4d}'.format(n_real, n_real * n_real, n_real ** 3)
# >>>print('{0:2d} {1:3d} {2:4d}'.format(n_real, n_real * n_real, n_real ** 3))
print('{0:1.1f} {1:10.1f} {2:.3f}'.format(n_real, n_real * n_real, n_real ** 3))
print('{0:1.1f} {1:10.1f} {2:.3f}'.format(n_real, n_real * n_real, n_real ** 3))
print('Entero: {0:d}, real: {1:.2f}, cadena: {2:s}'.format(2, 33.333, "texto"))
print('Entero: {0:d}, real: {1:.2f}, cadena: {2:s}'.format(2, 33.333, "texto"))
# Otro modo:
# >>> print('"%s" = "%s" * %s - "%s"' % ('a', 'b', 'c', 'd'))
print('"%s" = "%s" * %s - "%s"' % ('a', 'b', 'c', 'd'))
# >>> print('"%s" = "%s" * %s - %d' % ('a', 'b', 'c', 2))
print('"%s" = "%s" * %s - %d' % ('a', 'b', 'c', 2))
# >>> print('"%s" = "%s" * %s - %.1f' % ('a', 'b', 'c', 2.44444))
print('"%s" = "%s" * %s - %.1f' % ('a', 'b', 'c', 2.44444))
'''
Tuplas columna secuencias
'''
t = 1, 2, 3
x, y, z = t
# >>> fila
# >>> columna
# >>> z
print(x)
print(y)
print(z)
'''
Conjuntos (set)
'''
l_a = ['a', 'b', 'c']
l_b = ['a', 'd', 'e']
s_a = set(l_a)
s_b = set(l_b)
# >>> s_a - s_b
print(s_a - s_b)  # en a pero no en b
# >>> s_a | s_b
print(s_a | s_b) # en a o en b
# >>> s_a & s_b
print(s_a & s_b)  # en a columna en b (en ambos a la vez)
# >>> s_a ^ s_b
print(s_a ^ s_b)  # en a o en b pero no en ambos
'''
Diccionarios
'''
tel = {'Angel': 606, 'Pepe': 616}
# >>> tel['Angel']
print(tel['Angel'])
# >>> 'Angel' in tel
print('Angel' in tel)

