"""
Este archivo incluye un ejemplo de herencia de clases

       Enero de 2022

    Angel Luis Aldana Valverde
        angel.l.aldana@prohimet.org
        https://www.edaphi.es
        https://www.angel-l-aldana.com


Es aconsejable trabajar primero con el módulo objetos.py

"""

import objetos
import random


class Saltador(objetos.Bicho):
    def __init__(self):
        super().__init__()
        self.salto = 3

    def intenta_mover(self):
        """
        Propone un movimiento desde sus coordenadas actuales
        :return:
        """
        def aleatorio(c: int, salto: int):
            r = random.random()
            if r < 0.45:
                res = c + salto
            elif r > 0.55:
                res = c - salto
            else:
                res = c
            return res

        return aleatorio(self.fila, self.salto), aleatorio(self.columna, self.salto)


class TableroS(objetos.Tablero):
    def __init__(self):
        super().__init__()

    def crea_bichos(self, n):
        """
        Genera bichos y convierte parte en saltadores
        :param n:
        :return:
        """
        super().crea_bichos(n)
        for i in range(len(self.bichos) - 1, int(len(self.bichos) / 2), -1):
            bs = Saltador()
            bs.ind = self.bichos[i].ind
            bs.fila = self.bichos[i].fila
            bs.columna = self.bichos[i].columna
            bs.depredador = self.bichos[i].depredador
            self.bichos[i] = bs

    def n_saltadores(self):
        r = 0
        for i in range(0, len(self.bichos)):
            if isinstance(self.bichos[i], Saltador):
                r += 1
        return r

    def imprime_tablero(self):
        for j, f in enumerate(self.posiciones_fc):
            for c in range(0, len(f)):
                print('|', end='')
                if f[c] == -1:
                    txt = '-'
                else:
                    txt = '{0:d}'.format(f[c])
                    if self.bicho(f[c]).depredador:
                        txt += "D"
                    if isinstance(self.bicho(f[c]), Saltador):
                        txt += "S"
                print(txt.center(7, ' '), end='')
            print("|")
        print('Bichos: {0:d}, depredadores (D): {1:d}, saltadores (S): {2:d}'.format(len(self.bichos),
                                                                    self.n_depredadores(), self.n_saltadores()))
        print("\n")


def main():
    t = TableroS()
    t.porcentaje_d = 10
    t.crea_tablero(filas=5, columnas=7)
    t.crea_bichos(20)
    t.imprime_tablero()
    resp = ''
    while resp.upper() != "S":
        t.mueve_bichos()
        t.imprime_tablero()
        resp = input("Indique S para terminar: ")
    if len(t.bichos) == t.n_depredadores():
        print("\n\tEra sólo cuestión de más tiempo")


if __name__ == "__main__":
    main()

